Extension { #name : 'ClientForwarderSend' }

{ #category : 'Handling' }
ClientForwarderSend >> defaultAction [

"Return an error to the controlling GCI client. Stack is saved
 and available as an argument to the GCI error struct.

 instVars of the receiver go into the GCI error struct as follows
 self.receiver -->  GciErrSType.args[0]
 self.clientObj --> GciErrSType.args[1]
 self.selector -->  GciErrSType.args[2]
 self.gsArgs -->    GciErrSType.args[3]   (instVar defined in AbstractException)
"

<primitive: 33>  "this frame removed from stack before saving stack."
self _uncontinuableError

]

{ #category : 'Instance initialization' }
ClientForwarderSend >> initialize [
  gsNumber := ERR_ClientForwarderSend.
  gsResumable := true .
  gsTrappable := false . "should always go to the client"

]

{ #category : 'Instance initialization' }
ClientForwarderSend >> receiver: aSelf clientObj: aClientObj selector: aSymbol args: anArray [
  receiver := aSelf .
  clientObj := aClientObj .
  selector := aSymbol .
  gsArgs := anArray

]
